#ifndef QUALITY
#define QUALITY
#include "tinyxml.h"
#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include <curl.h>
#include <easy.h>
#include <time.h>
#include <stdio.h>
using namespace std;
string present_data();
string last_data();
string short_data_present();
string short_data_last();
int DST_files_download(string outputfilename);
int KP_files_download(string outputfilename);
int ACEMAG_files_download(string outputfilename);
int ACESWEPAM_files_download(string outputfilename);
void CongFileCreation(string output, string filenames_file);
void file_wright(string str, string outfile_name);
void data_file_download(string url_name, string file_name);
class FileName_Dir
{
	private:
		string File_Name_ACEMAG;
		string File_Name_ACESWEPAM;
		string File_Name_DST;
		string File_Name_KP;
		string File_Name_OUTPUT;
		string File_Dir_INPUT;
		string File_Dir_OUTPUT;
	public:
		FileName_Dir(): File_Name_ACEMAG(), File_Name_ACESWEPAM(), File_Name_DST(), File_Name_KP(), File_Name_OUTPUT(), File_Dir_INPUT(), File_Dir_OUTPUT()
		{}
		~FileName_Dir()
		{}
		void visitNode(TiXmlNode * root, int level, FileName_Dir str);
		void Name_show();
		void Dir_show();
		void Name_corect();
		void Dir_corect();
		string getFile_NameACEMAG();
		string getFile_NameACESWEPAM();
		string getFile_NameDST();
		string getFile_NameKP();
		string getFile_NameOutputfile();
		string getFile_DirInput();
		string getFile_DirOutput();
		void putName_ACEMAG(string strput);
		void putName_ACESWEPAM(string strput);
		void putName_DST(string strput);
		void putName_KP(string strput);
		void putName_OUTPUT(string strput);
};
string file_read(string infile_name);
extern string error_file;
string file_eraze(string str);
TiXmlDocument loadData(char* pFilename);
class InputData_analysis
{
	private:
		int NumberOfSymbols;
		int Month;
		string DataName;
	public:
		InputData_analysis(): NumberOfSymbols(0), Month(0), DataName("")
		{}
		~InputData_analysis ()
		{}
		void data_analysis(string str);
		string get_dataname();
		int get_numberOFSymbols();
};
int month_time();
int year_time();
int month_time_last();
int year_time_short();
int day_time();
int yearday_time();
int hour_time();
int min_time();
static size_t write_data(void *ptr, size_t size, size_t nmemb, FILE *stream);
int writer(char *data, size_t size, size_t nmemb, std::string *buffer);
static size_t my_fwrite(void *buffer, size_t size, size_t nmemb, void *stream);
int FilesInXmlTest(string inputfilename);
int FileStructureAnalysis2(string fileInstring);
void data_file_downloadftp(string url_name, string outputfile);
int FileStructureAnalysis3(string fileInstring);
string FileTimeForm();
#endif
